local DBar={};		--Array of all the damage bars
local HBar={};		--Array of all the healing bars

local CGaddonID = "CombatGraph";

--Is the player a healer?
CombatGraph_Bar2_Enabled=false;

--The timestep inbetween each update
CombatGraph_Timestep = 0.1;

--Current Sums for this timestep
local Damage_Current = 0;
local Healing_Current = 0;

--The Burst DPS sum
local Damage_Sum = 0;
local Healing_Sum = 0;

--Windows for adding to the running sum Burst DPS
DamageWindow={};
CombatGraph_DamageWindowSize=1;
HealingWindow={};
CombatGraph_HealingWindowSize=1;

--Average DPS & HPS windows
CombatGraph_AvgWindowSize=150;
local AvgDamageWindow={};
local AvgHealingWindow={};


--Falloff is what the current sum gets multiplied by before being added to this timesteps damage/healing
CombatGraph_Falloff  = 0.9;
--Integral is the area under the curve with the current falloff setting (its a geometric sum)
local Integral = 1 - (CombatGraph_Falloff)/(CombatGraph_Falloff-1);

--Peak Burst DPS & HPS for controlling the height of the peaks.
CombatGraph_PeakDPS = 500;
CombatGraph_PeakHPS = 2000;

--Is this the first timestep
local first = 1;

--Are we currently updating?
local updating = 0;


local currenttime = 0;
local lastcurrenttime = 0;
local starttime = 0;
local deltatime = 0;

--How many bars are there
local CombatGraph_Bars = 178;
local CombatGraph_MaxBars = 250;

--Height Settings
local BarHeight=48;
CombatGraph_FrameHeight=50;
CombatGraph_FrameWidth=182;

--Additional Frame Items to save
CombatGraph_Locked=false;
CombatGraph_Visible=true;
CombatGraph_Burst_Visible=true;
CombatGraph_Avg_Visible=true;

--Gradient Colors
CombatGraph_DPSColor_Top={};
CombatGraph_DPSColor_Bottom={};
CombatGraph_HPSColor_Top={};
CombatGraph_HPSColor_Bottom={};
CombatGraph_oldColor={};

--Frame Settings
CombatGraph_BackgroundStyle=1;
CombatGraph_BorderHorzInset=0;
CombatGraph_BorderVertInset=0;
CombatGraph_BGColor={r=0.0,g=0.0,b=0.0,a=0.4}
CombatGraph_BorderColor={r=0.0,g=0.0,b=0.0,a=0.4}

--Bar Settings
CG_DPS=1;
CG_RDPS=2;
CG_HPS=3;
CG_RHPS=4;
CombatGraph_Bar1_Target="";
CombatGraph_Bar1_Tracking=CG_DPS;
CombatGraph_Bar2_Target="";
CombatGraph_Bar2_Tracking=CG_HPS;

--Which Combat Events do we need to pay attn to?
local COMBAT_EVENTS = {
  ["SWING_DAMAGE"] = true,
  ["RANGE_DAMAGE"] = true,
  ["SPELL_DAMAGE"] = true,
  ["SPELL_PERIODIC_DAMAGE"] = true,
  ["ENVIRONMENTAL_DAMAGE"] = true,
  ["DAMAGE_SHIELD"] = true,
  ["DAMAGE_SPLIT"] = true,
  ["SPELL_HEAL"] = true,
  ["SPELL_PERIODIC_HEAL"] = true,
}


local COMBATGRAPH_SLASH_COMMAND = "/cg";

--This Function is From AllInOneInventory
function CombatGraph_Extract_NextParameter(msg)
	local params = msg;
	local command = params;
	local index = strfind(command, " ");
	if ( index ) then
		command = strsub(command, 1, index-1);
		params = strsub(params, index+1);
	else
		params = "";
	end
	return command, params;
end

function Combatgraph_UpdateTime()
	deltatime = 0;
	currenttime = GetTime();
end


function CombatGraph_Command(msg)
	msg = string.lower(msg);
	if( msg ) then
		local commandName, params = CombatGraph_Extract_NextParameter(msg);
		if( commandName == "" ) then
			if(CombatGraphOptions:IsVisible()) then
				CombatGraphOptions:Hide();				
			else
				CombatGraphOptions:Show();
			end
		elseif( commandName == "help" ) then
			DEFAULT_CHAT_FRAME:AddMessage("CombatGraph Commands", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" help - pops up this list of commands", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" options - Pops the option window up", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" toggle - Toggles whether CombatGraph is visible or not", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" togglelock - Toggles whether CombatGraph can be moved", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" height <frameheight> - Sets the new height of the frame (default 52 min 30 max 250)", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" width <framewidth> - Sets the new width of the frame (default 52 min 30 max 250)", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" falloff <falloff> - Controls the running sum falloff rate (range is 0.1-0.95)", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" PeakDPS <PeakDPS> - Basically whatever the max value for your peak DPS is on the graph", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" PeakHPS <PeakHPS> - Basically whatever the max value for your peak HPS is on the graph", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" timestep <timestep> - Adjust the timestep used for each line", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" avgwindow <windowsize> - Adjust the window used for determing average DPS & HPS", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" window <windowsize> - Adjust the window used for adding damage in to the running DPS Burst", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" hwindow <windowsize> - Adjust the window used for adding healing in to the running HPS Burst", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" gradient <BottomRed> <BottomGreen> <BottomBlue> <UpperRed> <UpperGreen> <UpperBlue> - Lets you set the gradient used for the DPS lines", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage(" hgradient <BottomRed> <BottomGreen> <BottomBlue> <UpperRed> <UpperGreen> <UpperBlue> - Lets you set the gradient used for the HPS lines", 1.0, 1.0, 0.0);
		elseif (commandName == "falloff") then
			CombatGraph_Falloff, params = CombatGraph_Extract_NextParameter(params);
			CombatGraph_Falloff = tonumber(CombatGraph_Falloff);
			if(CombatGraph_Falloff<0.1) then 
				CombatGraph_Falloff=0.1;
			elseif (CombatGraph_Falloff>0.95) then
				CombatGraph_Falloff=0.95;
			end
			CombatGraph_Falloff_Slider:SetValue(CombatGraph_Falloff);
			Integral = 1 - (CombatGraph_Falloff)/(CombatGraph_Falloff-1);
			DEFAULT_CHAT_FRAME:AddMessage(string.format("CombatGraph's falloff has been changed to %.2f",CombatGraph_Falloff), 1.0, 1.0, 0.0);
		elseif (commandName == "gradient") then
			local BR,BG,BB,UR,UG,UB;
			BR, params = CombatGraph_Extract_NextParameter(params);
			BG, params = CombatGraph_Extract_NextParameter(params);
			BB, params = CombatGraph_Extract_NextParameter(params);
			UR, params = CombatGraph_Extract_NextParameter(params);
			UG, params = CombatGraph_Extract_NextParameter(params);
			UB, params = CombatGraph_Extract_NextParameter(params);

			for i = 1, CombatGraph_Bars, 1 do
				DBar[i]:SetGradient("VERTICAL",tonumber(BR),tonumber(BG),tonumber(BB),tonumber(UR),tonumber(UG),tonumber(UB));
			end
		elseif (commandName == "hgradient") then
			local BR,BG,BB,UR,UG,UB;
			BR, params = CombatGraph_Extract_NextParameter(params);
			BG, params = CombatGraph_Extract_NextParameter(params);
			BB, params = CombatGraph_Extract_NextParameter(params);
			UR, params = CombatGraph_Extract_NextParameter(params);
			UG, params = CombatGraph_Extract_NextParameter(params);
			UB, params = CombatGraph_Extract_NextParameter(params);

			for i = 1, CombatGraph_Bars, 1 do
				HBar[i]:SetGradient("VERTICAL",tonumber(BR),tonumber(BG),tonumber(BB),tonumber(UR),tonumber(UG),tonumber(UB));
			end
		elseif (commandName == "peakdps") then
			CombatGraph_PeakDPS, params = CombatGraph_Extract_NextParameter(params);
			CombatGraph_PeakDPS = tonumber(CombatGraph_PeakDPS);
			if(CombatGraph_PeakDPS<5) then
				CombatGraph_PeakDPS=5;
			end
			DEFAULT_CHAT_FRAME:AddMessage("CombatGraph's peak DPS has been changed to "..CombatGraph_PeakHPS, 1.0, 1.0, 0.0);
		elseif (commandName == "peakhps") then
			CombatGraph_PeakHPS, params = CombatGraph_Extract_NextParameter(params);
			CombatGraph_PeakHPS = tonumber(CombatGraph_PeakHPS);
			if(CombatGraph_PeakHPS<5) then
				CombatGraph_PeakHPS=5;
			end
			DEFAULT_CHAT_FRAME:AddMessage("CombatGraph's peak HPS has been changed to "..CombatGraph_PeakHPS, 1.0, 1.0, 0.0);
		elseif (commandName == "timestep") then
			CombatGraph_Timestep, params = CombatGraph_Extract_NextParameter(params);
			CombatGraph_Timestep = tonumber(CombatGraph_Timestep);
			if(CombatGraph_Timestep<0.1) then
				CombatGraph_Timestep=0.1;
			elseif(CombatGraph_Timestep>1) then
				CombatGraph_Timestep=1;
			end
			CombatGraph_TimeStep_Slider:SetValue(CombatGraph_Timestep);
			DEFAULT_CHAT_FRAME:AddMessage("CombatGraph's time step has been changed to "..CombatGraph_Timestep.." second(s)", 1.0, 1.0, 0.0);
		elseif (commandName == "window") then
			CombatGraph_AverageWindowSize, params =CombatGraph_Extract_NextParameter(params);
			
			CombatGraph_AverageWindowSize = tonumber(CombatGraph_AverageWindowSize);

			if (CombatGraph_AverageWindowSize<50) then
				CombatGraph_AverageWindowSize=50;
			elseif (CombatGraph_AverageWindowSize>300) then
				CombatGraph_AverageWindowSize=300;
			end

			for i = 1, CombatGraph_AvgWindowSize, 1 do
				AvgDamageWindow[i]=0;
				AvgHealingWindow[i]=0;
			end
			DEFAULT_CHAT_FRAME:AddMessage("CombatGraph's Damage Window has been set to "..CombatGraph_DamageWindowSize.." which is a time window of "..CombatGraph_DamageWindowSize*CombatGraph_Timestep.." second(s)", 1.0, 1.0, 0.0);
		elseif (commandName == "window") then
			CombatGraph_DamageWindowSize, params =CombatGraph_Extract_NextParameter(params);
			
			CombatGraph_DamageWindowSize = tonumber(CombatGraph_DamageWindowSize);

			if (CombatGraph_DamageWindowSize<1) then
				CombatGraph_DamageWindowSize=1;
			elseif (CombatGraph_DamageWindowSize>100) then
				CombatGraph_DamageWindowSize=100;
			end

			for i = 1, CombatGraph_DamageWindowSize, 1 do
				DamageWindow[i]=0;
			end
			DEFAULT_CHAT_FRAME:AddMessage("CombatGraph's Damage Window has been set to "..CombatGraph_DamageWindowSize.." which is a time window of "..CombatGraph_DamageWindowSize*CombatGraph_Timestep.." second(s)", 1.0, 1.0, 0.0);
		elseif (commandName == "hwindow") then
			CombatGraph_HealingWindowSize, params =CombatGraph_Extract_NextParameter(params);
			
			CombatGraph_HealingWindowSize = tonumber(CombatGraph_HealingWindowSize);

			if (CombatGraph_HealingWindowSize<1) then
				CombatGraph_HealingWindowSize=1;
			elseif (CombatGraph_HealingWindowSize>100) then
				CombatGraph_HealingWindowSize=100;
			end

			for i = 1, CombatGraph_HealingWindowSize, 1 do
				HealingWindow[i]=0;
			end
			DEFAULT_CHAT_FRAME:AddMessage("CombatGraph's Healing Window has been set to "..CombatGraph_HealingWindowSize.." which is a time window of "..CombatGraph_HealingWindowSize*CombatGraph_Timestep.." second(s)", 1.0, 1.0, 0.0);
		elseif (commandName == "height") then
			CombatGraph_FrameHeight, params =CombatGraph_Extract_NextParameter(params);
			CombatGraph_FrameHeight = tonumber(CombatGraph_FrameHeight);

			if(CombatGraph_FrameHeight<30) then
				CombatGraph_FrameHeight=30;
			elseif (CombatGraph_FrameHeight>250) then
				CombatGraph_FrameHeight=250;
			end

			CombatGraphFrame:SetHeight(CombatGraph_FrameHeight);

			OldBarHeight=BarHeight;
			BarHeight=CombatGraph_FrameHeight-4;

			for i=1, CombatGraph_Bars, 1 do
				t=DBar[i]:GetHeight();
				DBar[i]:SetHeight(t/OldBarHeight*BarHeight);

				t=HBar[i]:GetHeight();
				HBar[i]:SetHeight(t/OldBarHeight*BarHeight);
			end

			CombatGraph_FrameHeight_Slider:SetValue(CombatGraph_FrameHeight);

			DEFAULT_CHAT_FRAME:AddMessage("CombatGraph height set to "..CombatGraph_FrameHeight, 1.0, 1.0, 0.0);
		elseif (commandName == "width") then
			CombatGraph_FrameWidth, params =CombatGraph_Extract_NextParameter(params);
			CombatGraph_FrameWidth = tonumber(CombatGraph_FrameHeight);

			if(CombatGraph_FrameWidth<150) then
				CombatGraph_FrameHeight=150;
			elseif (CombatGraph_FrameHeight>250) then
				CombatGraph_FrameHeight=250;
			end
				
			CombatGraph_SetFrame();

			CombatGraph_FrameWidth_Slider:SetValue(CombatGraph_FrameWidth);

			DEFAULT_CHAT_FRAME:AddMessage("CombatGraph height set to "..CombatGraph_FrameHeight, 1.0, 1.0, 0.0);
		elseif (commandName == "togglelock") then
			if (not CombatGraphFrame.isLocked) or ( this.isLocked == 0 ) then
				CombatGraph_Locked=true;
				CombatGraphFrame.isLocked=true;
				DEFAULT_CHAT_FRAME:AddMessage("CombatGraph is Locked", 1.0, 1.0, 0.0);

				if ( CombatGraphFrame.isMoving ) then
				  CombatGraphFrame:StopMovingOrSizing();
				end
				CombatGraphFrame:EnableMouse(false);
			else
				CombatGraph_Locked=false;
				CombatGraphFrame.isLocked=false;
				CombatGraphFrame:EnableMouse(true);
				DEFAULT_CHAT_FRAME:AddMessage("CombatGraph is Unlocked", 1.0, 1.0, 0.0);
			end
			CombatGraph_Locked_CheckBox:SetChecked(CombatGraph_Locked);
		elseif (commandName == "toggle") then
			if(CombatGraphFrame:IsVisible()) then
				CombatGraph_Visible=false;
				DEFAULT_CHAT_FRAME:AddMessage("CombatGraph is Hidden", 1.0, 1.0, 0.0);
				CombatGraph_UnregisterEvents();
				CombatGraphFrame:Hide();
			else
				CombatGraph_Visible=true;
				DEFAULT_CHAT_FRAME:AddMessage("CombatGraph is Shown", 1.0, 1.0, 0.0);
				CombatGraph_RegisterEvents();
				Combatgraph_UpdateTime();
				CombatGraphFrame:Show();				
			end
			CombatGraph_Visible_CheckBox:SetChecked(CombatGraph_Visible);
		elseif (commandName == "options") then
			if(CombatGraphOptions:IsVisible()) then
				PlaySound("igMainMenuOptionCheckBoxOff");
				CombatGraphOptions:Hide();
			else
				PlaySound("igMainMenuOptionCheckBoxOn");
				CombatGraphOptions:Show();
			end
		end

		
	end
end

function CombatGraph_UpdateBars()
	HInset=CombatGraph_BorderHorzInset+1;
	VInset=CombatGraph_BorderVertInset+1;
	for i = 1, CombatGraph_MaxBars, 1 do		
		DBar[i]:ClearAllPoints();
		DBar[i]:SetPoint("BOTTOMRIGHT","CombatGraphFrame","BOTTOMRIGHT",-(HInset+i-1),VInset);
		
		HBar[i]:ClearAllPoints();
		HBar[i]:SetPoint("BOTTOMRIGHT","CombatGraphFrame","BOTTOMRIGHT",-(HInset+i-1),VInset);
	end

	for i = CombatGraph_Bars+1, CombatGraph_MaxBars, 1 do
		DBar[i]:Hide();
		HBar[i]:Hide();
	end
end

function CombatGraph_SetFrame()
	local bgtexture = "Interface\\AddOns\\CombatGraph\\textures\\PlainBackdrop";
	if (CombatGraph_BackgroundStyle == 1) then
		CombatGraphFrame:SetBackdrop({bgFile = bgtexture, edgeFile = "Interface\\AddOns\\CombatGraph\\textures\\PlainBackdrop", tile = nil, tileSize = 1, edgeSize = 1, insets = { left = 1, right = 1, top = 1, bottom = 1 }});
		CombatGraph_BorderHorzInset=1;
		CombatGraph_BorderVertInset=1;
	elseif (CombatGraph_BackgroundStyle == 2) then
		CombatGraphFrame:SetBackdrop({bgFile = bgtexture, edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = nil, tileSize = 16, edgeSize = 16, insets = { left = 5, right = 5, top = 5, bottom = 5 }});
		CombatGraph_BorderHorzInset=5;
		CombatGraph_BorderVertInset=5;
	elseif (CombatGraph_BackgroundStyle == 3) then
		CombatGraphFrame:SetBackdrop({bgFile = bgtexture, edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = nil, tileSize = 32, edgeSize = 32, insets = { left = 11, right = 12, top = 12, bottom = 11 }});
		CombatGraph_BorderHorzInset=12;
		CombatGraph_BorderVertInset=11.5;
	elseif (CombatGraph_BackgroundStyle == 4) then
		CombatGraphFrame:SetBackdrop({bgFile = bgtexture, edgeFile = "Interface\\Buttons\\UI-SliderBar-Border", tile = nil, tileSize = 8, edgeSize = 8, insets = { left = 3, right = 3, top = 6, bottom = 6 }});
		CombatGraph_BorderHorzInset=3;
		CombatGraph_BorderVertInset=6;
	end

	CombatGraphFrame:SetWidth(CombatGraph_FrameWidth);
	CombatGraphFrame:SetHeight(CombatGraph_FrameHeight);

	OldBarHeight=BarHeight;
	BarHeight=CombatGraph_FrameHeight-4-(2*CombatGraph_BorderVertInset);

	for i=1, CombatGraph_Bars, 1 do
		t=DBar[i]:GetHeight();
		DBar[i]:SetHeight(t/OldBarHeight*BarHeight);

		t=HBar[i]:GetHeight();
		HBar[i]:SetHeight(t/OldBarHeight*BarHeight);
	end

	CombatGraphFrame:SetBackdropColor(CombatGraph_BGColor.r, CombatGraph_BGColor.g, CombatGraph_BGColor.b, CombatGraph_BGColor.a);
	CombatGraphFrame:SetBackdropBorderColor(CombatGraph_BorderColor.r, CombatGraph_BorderColor.g, CombatGraph_BorderColor.b, CombatGraph_BorderColor.a);

	CombatGraph_Bars=CombatGraph_FrameWidth-3-(2*CombatGraph_BorderHorzInset);
	

	CombatGraph_UpdateBars();

	DPS_Text1:ClearAllPoints();
	DPS_Text1:SetPoint("TOPLEFT","CombatGraphFrame","TOPLEFT",1+CombatGraph_BorderHorzInset,-(4+CombatGraph_BorderVertInset));

	HPS_Text2:ClearAllPoints();
	HPS_Text2:SetPoint("TOPRIGHT","CombatGraphFrame","TOPRIGHT",-(2+CombatGraph_BorderHorzInset),-(4+CombatGraph_BorderVertInset));
end

function CombatGraph_RegisterEvents()

	this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

end

function CombatGraph_UnregisterEvents()

	this:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

end

-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CombatGraph_OnLoad()
	CurrentPlayer=UnitName("Player");
	--Register the events
	CombatGraph_RegisterEvents();
	this:RegisterEvent("ADDON_LOADED");

	--Stuff to recalculate and reset after a loadup
	Integral = 1 - (CombatGraph_Falloff)/(CombatGraph_Falloff-1);

	CombatGraphFrame:SetHeight(CombatGraph_FrameHeight);
	--BG1:SetHeight(CombatGraph_FrameHeight);

	BarHeight=CombatGraph_FrameHeight-4;

	CombatGraphFrame.isLocked=CombatGraph_Locked;

	if(CombatGraph_Locked) then
		CombatGraphFrame:EnableMouse(false);
	else
		CombatGraphFrame:EnableMouse(true);
	end

	if(CombatGraph_Visible) then
		CombatGraphFrame:Show();
	else
		CombatGraphFrame:Hide();
	end
	CombatGraph_Visible_CheckBox:SetChecked(CombatGraph_Visible);

	--Register the slash commands
	SLASH_CG1 = COMBATGRAPH_SLASH_COMMAND;
	SlashCmdList["CG"] = function(msg)
		CombatGraph_Command(msg);
	end

	
	
	CombatGraph_DPSColor_Top.r=1;
	CombatGraph_DPSColor_Top.g=0;
	CombatGraph_DPSColor_Top.b=0;
	CombatGraph_DPSColor_Bottom.r=0.1;
	CombatGraph_DPSColor_Bottom.g=0;
	CombatGraph_DPSColor_Bottom.b=0;
	CombatGraph_HPSColor_Top.r=0;
	CombatGraph_HPSColor_Top.g=1;
	CombatGraph_HPSColor_Top.b=0;
	CombatGraph_HPSColor_Bottom.r=0;
	CombatGraph_HPSColor_Bottom.g=0.1;
	CombatGraph_HPSColor_Bottom.b=0;

	--Setup the bars
	for i = 1, CombatGraph_MaxBars, 1 do
		DBar[i]=getglobal("DamageBar_"..i);
		DBar[i]:SetGradient("VERTICAL",CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b,CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
		DBar[i]:SetHeight(0);
		DBar[i]:Hide();

		HBar[i]=getglobal("HealingBar_"..i);
		HBar[i]:SetGradient("VERTICAL",CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b,CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
		HBar[i]:SetHeight(0);
		HBar[i]:Hide();
	end

	CombatGraph_UpdateBars();

	

	

	DPSColor_Top_Button_BG:SetVertexColor(CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
	DPSColor_Bottom_Button_BG:SetVertexColor(CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b);
	DPS_Gradient:SetGradient("VERTICAL",CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b,CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);

	HPSColor_Top_Button_BG:SetVertexColor(CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
	HPSColor_Bottom_Button_BG:SetVertexColor(CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b);
	HPS_Gradient:SetGradient("VERTICAL",CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b,CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);

	--Can this player heal?
	local playerClass, englishClass = UnitClass("player");

	if (englishClass=="SHAMAN") or (englishClass=="DRUID") or (englishClass=="PRIEST") or (englishClass=="WARRIOR") or (englishClass=="PALADIN") or (englishClass=="WARLOCK") then
		CombatGraph_Bar2_Enabled=true;
	else
		CombatGraph_Bar2_Enabled=false;
		HPS_Text1:Hide();
		HPS_Text2:Hide();
		AvgHPS_Text1:Hide();
		AvgHPS_Text2:Hide();

		AvgDPS_Text1:ClearAllPoints();
		AvgDPS_Text1:SetPoint("TOPLEFT","HPS_Text1","TOPLEFT",0,0);
		AvgDPS_Text2:ClearAllPoints();
		AvgDPS_Text2:SetPoint("TOPRIGHT","HPS_Text2","TOPRIGHT",0,0);
	end


	--Initialize the windows
	for i = 1, CombatGraph_DamageWindowSize, 1 do
		DamageWindow[i]=0;
	end
	for i = 1, CombatGraph_HealingWindowSize, 1 do
		HealingWindow[i]=0;
	end

	for i = 1, CombatGraph_AvgWindowSize, 1 do
		AvgDamageWindow[i]=0;
		AvgHealingWindow[i]=0;
	end

	CombatGraph_SetFrame();
	
	--Bar Tracking settings
	CombatGraph_Bar1_Target=CurrentPlayer;
	CombatGraph_Bar2_Target=CurrentPlayer;
	CombatGraph_Bar1_Tracking=CG_DPS;
	CombatGraph_Bar2_Tracking=CG_HPS;

	--Well we are finished loading
	DEFAULT_CHAT_FRAME:AddMessage("CombatGraph 1.3.1 Loaded",1,1,0);
	DEFAULT_CHAT_FRAME:AddMessage(" Commands can be accessed through /cg help",1,1,0);

end
-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CombatGraph_OnEvent(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, ...)

	if ((event == "ADDON_LOADED") and (arg1 == "CombatGraph")) then
		Integral = 1 - (CombatGraph_Falloff)/(CombatGraph_Falloff-1);

		CombatGraph_SetFrame();

		CombatGraphFrame.isLocked=CombatGraph_Locked;
		if(CombatGraph_Locked) then
			CombatGraphFrame:EnableMouse(false);
		else
			CombatGraphFrame:EnableMouse(true);
		end
		if(CombatGraph_Visible) then
			CombatGraphFrame:Show();
		else
			CombatGraphFrame:Hide();
		end
		
		--Initialize the windows
		for i = 1, CombatGraph_DamageWindowSize, 1 do
			DamageWindow[i]=0;
		end
		for i = 1, CombatGraph_HealingWindowSize, 1 do
			HealingWindow[i]=0;
		end

		--Update Options Frame
		CombatGraph_Visible_CheckBox:SetChecked(CombatGraph_Visible);
		CombatGraph_Locked_CheckBox:SetChecked(CombatGraph_Locked);
		CombatGraph_Falloff_Slider:SetValue(CombatGraph_Falloff);
		CombatGraph_TimeStep_Slider:SetValue(CombatGraph_Timestep);
		CombatGraph_AvgWindow_Slider:SetValue(CombatGraph_AvgWindowSize);
		CombatGraph_FrameHeight_Slider:SetValue(CombatGraph_FrameHeight);
		CombatGraph_FrameWidth_Slider:SetValue(CombatGraph_FrameWidth);
		CombatGraph_PeakDPS_Slider:SetValue(CombatGraph_PeakDPS);
		CombatGraph_DPSWindow_Slider:SetValue(CombatGraph_DamageWindowSize);
		CombatGraph_PeakHPS_Slider:SetValue(CombatGraph_PeakHPS);
		CombatGraph_HPSWindow_Slider:SetValue(CombatGraph_HealingWindowSize);
	
		DPSColor_Top_Button_BG:SetVertexColor(CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
		DPSColor_Bottom_Button_BG:SetVertexColor(CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b);
		DPS_Gradient:SetGradient("VERTICAL",CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b,CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
		
		HPSColor_Top_Button_BG:SetVertexColor(CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
		HPSColor_Bottom_Button_BG:SetVertexColor(CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b);
		HPS_Gradient:SetGradient("VERTICAL",CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b,CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
		
		for i = 1, CombatGraph_Bars, 1 do
			DBar[i]:SetGradient("VERTICAL",CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b,CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
			HBar[i]:SetGradient("VERTICAL",CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b,CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
		end


		CombatGraph_BurstDPS_CheckBox:SetChecked(CombatGraph_Burst_Visible);
		CombatGraph_AvgDPS_CheckBox:SetChecked(CombatGraph_Avg_Visible);
		CombatGraph_BurstDPS_Clicked();
		CombatGraph_AvgDPS_Clicked();


		CombatGraph_BorderColor_BG:SetVertexColor(CombatGraph_BorderColor.r,CombatGraph_BorderColor.g,CombatGraph_BorderColor.b);
		CombatGraph_BGColor_BG:SetVertexColor(CombatGraph_BGColor.r,CombatGraph_BGColor.g,CombatGraph_BGColor.b);
		
		
		CombatGraph_Bar1_Tracking_Text:SetText("Tracking: "..CombatGraph_Bar1_Target);
		CombatGraph_Bar2_Tracking_Text:SetText("Tracking: "..CombatGraph_Bar2_Target);
		
	elseif (event == "COMBAT_LOG_EVENT_UNFILTERED") then    
		ParseCombat(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12)
	
	end
end

-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CombatGraph_UpdateDisplay()
	for i = 0, CombatGraph_Bars-2, 1 do
		DBar[CombatGraph_Bars-i]:SetHeight(DBar[CombatGraph_Bars-i-1]:GetHeight());
		HBar[CombatGraph_Bars-i]:SetHeight(HBar[CombatGraph_Bars-i-1]:GetHeight());
		if(DBar[CombatGraph_Bars-i-1]:IsVisible()) then
			DBar[CombatGraph_Bars-i]:Show();
		else
			DBar[CombatGraph_Bars-i]:Hide();
		end
		if(HBar[CombatGraph_Bars-i-1]:IsVisible()) then
			HBar[CombatGraph_Bars-i]:Show();
		else
			HBar[CombatGraph_Bars-i]:Hide();
		end
	end

	for i = 0, CombatGraph_DamageWindowSize-2,1 do
		DamageWindow[CombatGraph_DamageWindowSize-i]=DamageWindow[CombatGraph_DamageWindowSize-i-1];
	end
	DamageWindow[1]=Damage_Current;

	DamageWindowSum=0;
	for i = 1, CombatGraph_DamageWindowSize,1 do
		DamageWindowSum=DamageWindow[i]+DamageWindowSum;
	end

	DamageAdd=DamageWindowSum/CombatGraph_DamageWindowSize;

	Damage_Sum = DamageAdd + CombatGraph_Falloff*Damage_Sum;

	for i = 0, CombatGraph_HealingWindowSize-2,1 do
		HealingWindow[CombatGraph_HealingWindowSize-i]=HealingWindow[CombatGraph_HealingWindowSize-i-1];
	end
	HealingWindow[1]=Healing_Current;

	HealingWindowSum=0;
	for i = 1, CombatGraph_HealingWindowSize,1 do
		HealingWindowSum=HealingWindow[i]+HealingWindowSum;
	end

	HealingAdd=HealingWindowSum/CombatGraph_HealingWindowSize;

	Healing_Sum = HealingAdd + CombatGraph_Falloff*Healing_Sum;




	CurDPS = Damage_Sum/Integral/CombatGraph_Timestep;
	CurHPS = Healing_Sum/Integral/CombatGraph_Timestep

	NewBarHeight = BarHeight*CurDPS/CombatGraph_PeakDPS;
	if (NewBarHeight>BarHeight) then
		NewBarHeight=BarHeight;
	end

	if (NewBarHeight > 0.5) then
		DBar[1]:Show();
		DBar[1]:SetHeight(NewBarHeight);
	else
		DBar[1]:Hide();
		CurDPS=0;
	end
	DBarHeight=NewBarHeight;

	if (CombatGraph_Bar2_Enabled) then
		NewBarHeight = BarHeight*CurHPS/CombatGraph_PeakHPS;
		if (NewBarHeight>BarHeight) then
			NewBarHeight=BarHeight;
		end

		if (NewBarHeight > 0.5) then
			HBar[1]:Show();
			HBar[1]:SetHeight(NewBarHeight);
		else
			HBar[1]:Hide();
			CurHPS=0;
		end
		HPS_Text2:SetText(math.floor(CurHPS));
	end 

	DPS_Text2:SetText(math.floor(CurDPS));

	--Calculating Average DPS from the windows of burst DPS
	for i = 0, CombatGraph_AvgWindowSize-2, 1 do
		AvgDamageWindow[CombatGraph_AvgWindowSize-i]=AvgDamageWindow[CombatGraph_AvgWindowSize-i-1];
		AvgHealingWindow[CombatGraph_AvgWindowSize-i]=AvgHealingWindow[CombatGraph_AvgWindowSize-i-1];
	end
	AvgDamageWindow[1]=CurDPS;
	AvgHealingWindow[1]=CurHPS;

	AvgDPS=0;
	AvgHPS=0;
	for i = 1, CombatGraph_AvgWindowSize, 1 do
		AvgDPS=AvgDPS+AvgDamageWindow[i];
		AvgHPS=AvgHPS+AvgHealingWindow[i];
	end

	AvgDPS=AvgDPS/CombatGraph_AvgWindowSize;
	AvgHPS=AvgHPS/CombatGraph_AvgWindowSize;

	AvgDPS_Text2:SetText(math.floor(AvgDPS));
	AvgHPS_Text2:SetText(math.floor(AvgHPS));

	CombatGraph_BurstDPS_CheckBox:SetChecked(CombatGraph_Burst_Visible);
	CombatGraph_AvgDPS_CheckBox:SetChecked(CombatGraph_Avg_Visible);
	CombatGraph_BurstDPS_Clicked();
	CombatGraph_AvgDPS_Clicked();

end

--Update Function
function CombatGraph_OnUpdate()
	if (first == 1) then
		starttime = GetTime();
		currenttime = GetTime();
		first = 0;
	end
	lastcurrenttime = currenttime;
	currenttime = GetTime();
	d = currenttime - lastcurrenttime;
	-- d is time since the last update
	deltatime = deltatime + d;
	while (deltatime > CombatGraph_Timestep - 0.01) do
		if (updating == 0) then
			updating = 1;
			CombatGraph_UpdateDisplay();
			deltatime = deltatime - CombatGraph_Timestep;
			Damage_Current = 0;
			Healing_Current = 0;
			updating = 0;
		end
	end
end



--All the Option Frame Functions
-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CombatGraph_FalloffSliderUpdate()
	CombatGraph_Falloff=CombatGraph_Falloff_Slider:GetValue();
	Integral = 1 - (CombatGraph_Falloff)/(CombatGraph_Falloff-1);
end

-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CombatGraph_SetNewAvgWindow(Num)

	CombatGraph_AvgWindowSize=Num;
	for i = 1, CombatGraph_AvgWindowSize, 1 do
		AvgDamageWindow[i]=0;
		AvgHealingWindow[i]=0;
	end
end

-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CombatGraph_Locked_Clicked()
	if(CombatGraph_Locked_CheckBox:GetChecked()) then
		CombatGraph_Locked=true;
		CombatGraphFrame.isLocked=true;
	else 
		CombatGraph_Locked=false;
		CombatGraphFrame.isLocked=false;
	end
	if(CombatGraph_Locked) then
		CombatGraphFrame:EnableMouse(false);
	else
		CombatGraphFrame:EnableMouse(true);
	end
end

-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CombatGraph_Visible_Clicked()
	if(CombatGraph_Visible_CheckBox:GetChecked()) then
		CombatGraph_Visible=true;		
		CombatGraph_RegisterEvents();
		Combatgraph_UpdateTime();
		CombatGraphFrame:Show();
	else		
		CombatGraph_Visible=false;
		CombatGraph_UnregisterEvents();
		CombatGraphFrame:Hide();
	end
end

function CombatGraph_BurstDPS_Clicked()
	if(CombatGraph_BurstDPS_CheckBox:GetChecked()) then
		DPS_Text1:Show();
		DPS_Text2:Show();

		AvgDPS_Text1:ClearAllPoints();
		AvgDPS_Text1:SetPoint("TOPLEFT","DPS_Text1","BOTTOMLEFT",0,-2);
		AvgDPS_Text2:ClearAllPoints();
		AvgDPS_Text2:SetPoint("TOPRIGHT","DPS_Text2","BOTTOMRIGHT",0,-2);

		if(CombatGraph_Bar2_Enabled) then
			HPS_Text1:Show();
			HPS_Text2:Show();
		else
			AvgDPS_Text1:ClearAllPoints();
			AvgDPS_Text1:SetPoint("TOPLEFT","HPS_Text1","TOPLEFT",0,0);
			AvgDPS_Text2:ClearAllPoints();
			AvgDPS_Text2:SetPoint("TOPRIGHT","HPS_Text2","TOPRIGHT",0,0);
		end
		
		AvgHPS_Text1:ClearAllPoints();
		AvgHPS_Text1:SetPoint("TOPLEFT","HPS_Text1","BOTTOMLEFT",0,-2);
		AvgHPS_Text2:ClearAllPoints();
		AvgHPS_Text2:SetPoint("TOPRIGHT","HPS_Text2","BOTTOMRIGHT",0,-2);

		
		
		CombatGraph_Burst_Visible=true;
	else 
		DPS_Text1:Hide();
		DPS_Text2:Hide();

		AvgDPS_Text1:ClearAllPoints();
		AvgDPS_Text1:SetPoint("TOPLEFT","DPS_Text1","TOPLEFT");
		AvgDPS_Text2:ClearAllPoints();
		AvgDPS_Text2:SetPoint("TOPRIGHT","DPS_Text2","TOPRIGHT");

		HPS_Text1:Hide();
		HPS_Text2:Hide();

		AvgHPS_Text1:ClearAllPoints();
		AvgHPS_Text1:SetPoint("TOPLEFT","HPS_Text1","TOPLEFT");
		AvgHPS_Text2:ClearAllPoints();
		AvgHPS_Text2:SetPoint("TOPRIGHT","HPS_Text2","TOPRIGHT");

		CombatGraph_Burst_Visible=false;
	end
end

function CombatGraph_AvgDPS_Clicked()
	if(CombatGraph_AvgDPS_CheckBox:GetChecked()) then
		AvgDPS_Text1:Show();
		AvgDPS_Text2:Show();
		if(CombatGraph_Bar2_Enabled) then
			AvgHPS_Text1:Show();
			AvgHPS_Text2:Show();
		end
		CombatGraph_Avg_Visible=true;
	else 
		AvgDPS_Text1:Hide();
		AvgDPS_Text2:Hide();
		AvgHPS_Text1:Hide();
		AvgHPS_Text2:Hide();
		CombatGraph_Avg_Visible=false;
	end
end

function CombatGraph_DPSColor_Top_Change()
	local r, g, b = ColorPickerFrame:GetColorRGB();

	CombatGraph_DPSColor_Top.r=r;
	CombatGraph_DPSColor_Top.g=g;
	CombatGraph_DPSColor_Top.b=b;

	DPSColor_Top_Button_BG:SetVertexColor(CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
	for i = 1, CombatGraph_Bars, 1 do
		DBar[i]:SetGradient("VERTICAL",CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b,CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
	end
	DPS_Gradient:SetGradient("VERTICAL",CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b,CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
end

function CombatGraph_DPSColor_Top_Cancel(prev)

	CombatGraph_DPSColor_Top=prev;

	DPSColor_Top_Button_BG:SetVertexColor(CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
	for i = 1, CombatGraph_Bars, 1 do
		DBar[i]:SetGradient("VERTICAL",CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b,CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
	end
	DPS_Gradient:SetGradient("VERTICAL",CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b,CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
end

-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CombatGraph_DPSColor_Bottom_Change()
	local r, g, b = ColorPickerFrame:GetColorRGB();

	CombatGraph_DPSColor_Bottom.r=r;
	CombatGraph_DPSColor_Bottom.g=g;
	CombatGraph_DPSColor_Bottom.b=b;

	DPSColor_Bottom_Button_BG:SetVertexColor(CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b);
	for i = 1, CombatGraph_Bars, 1 do
		DBar[i]:SetGradient("VERTICAL",CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b,CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
	end
	DPS_Gradient:SetGradient("VERTICAL",CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b,CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
end

-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CombatGraph_DPSColor_Bottom_Cancel()

	CombatGraph_DPSColor_Bottom=ColorPickerFrame.previousValues;

	DPSColor_Bottom_Button_BG:SetVertexColor(CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b);
	for i = 1, CombatGraph_Bars, 1 do
		DBar[i]:SetGradient("VERTICAL",CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b,CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
	end
	DPS_Gradient:SetGradient("VERTICAL",CombatGraph_DPSColor_Bottom.r,CombatGraph_DPSColor_Bottom.g,CombatGraph_DPSColor_Bottom.b,CombatGraph_DPSColor_Top.r,CombatGraph_DPSColor_Top.g,CombatGraph_DPSColor_Top.b);
end

-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CombatGraph_HPSColor_Top_Change()
	local r, g, b = ColorPickerFrame:GetColorRGB();

	CombatGraph_HPSColor_Top.r=r;
	CombatGraph_HPSColor_Top.g=g;
	CombatGraph_HPSColor_Top.b=b;

	HPSColor_Top_Button_BG:SetVertexColor(CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
	for i = 1, CombatGraph_Bars, 1 do
		HBar[i]:SetGradient("VERTICAL",CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b,CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
	end
	HPS_Gradient:SetGradient("VERTICAL",CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b,CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
end

function CombatGraph_HPSColor_Top_Cancel(prev)

	CombatGraph_HPSColor_Top=prev;

	HPSColor_Top_Button_BG:SetVertexColor(CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
	for i = 1, CombatGraph_Bars, 1 do
		HBar[i]:SetGradient("VERTICAL",CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b,CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
	end
	HPS_Gradient:SetGradient("VERTICAL",CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b,CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
end

function CombatGraph_HPSColor_Bottom_Change()
	local r, g, b = ColorPickerFrame:GetColorRGB();

	CombatGraph_HPSColor_Bottom.r=r;
	CombatGraph_HPSColor_Bottom.g=g;
	CombatGraph_HPSColor_Bottom.b=b;

	HPSColor_Bottom_Button_BG:SetVertexColor(CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b);
	for i = 1, CombatGraph_Bars, 1 do
		HBar[i]:SetGradient("VERTICAL",CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b,CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
	end
	HPS_Gradient:SetGradient("VERTICAL",CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b,CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
end

function CombatGraph_HPSColor_Bottom_Cancel()

	CombatGraph_HPSColor_Bottom=ColorPickerFrame.previousValues;

	HPSColor_Bottom_Button_BG:SetVertexColor(CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b);
	for i = 1, CombatGraph_Bars, 1 do
		HBar[i]:SetGradient("VERTICAL",CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b,CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
	end
	HPS_Gradient:SetGradient("VERTICAL",CombatGraph_HPSColor_Bottom.r,CombatGraph_HPSColor_Bottom.g,CombatGraph_HPSColor_Bottom.b,CombatGraph_HPSColor_Top.r,CombatGraph_HPSColor_Top.g,CombatGraph_HPSColor_Top.b);
end

function CombatGraph_FrameHeight_Slider_Change()
	CombatGraphFrame:SetHeight(CombatGraph_FrameHeight);
	
	OldBarHeight=BarHeight;
	BarHeight=CombatGraph_FrameHeight-4;

	for i=1, CombatGraph_Bars, 1 do
		t=DBar[i]:GetHeight();
		DBar[i]:SetHeight(t/OldBarHeight*BarHeight);

		t=HBar[i]:GetHeight();
		HBar[i]:SetHeight(t/OldBarHeight*BarHeight);
	end
end

-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CombatGraph_DropDown_OnLoad()
	UIDropDownMenu_Initialize(this, CombatGraph_DropDown_Initialize);
end

-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CombatGraph_DropDown_Initialize()	
	info = {};
	info.text = "Plain";
	info.value = 1;
	info.func = CombatGraph_DropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Tooltip";
	info.value = 2;
	info.func = CombatGraph_DropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Dialogue";
	info.value = 3;
	info.func = CombatGraph_DropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Slider";
	info.value = 4;
	info.func = CombatGraph_DropDown_OnClick;
	UIDropDownMenu_AddButton(info);
	
	UIDropDownMenu_SetSelectedID(CombatGraph_DropDown,CombatGraph_BackgroundStyle);
end

function CombatGraph_DropDown_OnClick()
	UIDropDownMenu_SetSelectedValue(CombatGraph_DropDown, this.value);
	CombatGraph_BackgroundStyle=this.value;
	CombatGraph_SetFrame();
end

function CombatGraph_BorderColor_Change()
	local r, g, b = ColorPickerFrame:GetColorRGB();

	CombatGraph_BorderColor.r=r;
	CombatGraph_BorderColor.g=g;
	CombatGraph_BorderColor.b=b;
	CombatGraph_SetFrame();

	CombatGraph_BorderColor_BG:SetVertexColor(CombatGraph_BorderColor.r,CombatGraph_BorderColor.g,CombatGraph_BorderColor.b);
end

function CombatGraph_BorderColor_Cancel(prev)

	CombatGraph_BorderColor=prev;
	CombatGraph_SetFrame();
	CombatGraph_BorderColor_BG:SetVertexColor(CombatGraph_BorderColor.r,CombatGraph_BorderColor.g,CombatGraph_BorderColor.b);
end
function CombatGraph_BorderOpacity_Change()

	CombatGraph_BorderColor.a=1.0-OpacitySliderFrame:GetValue();
	CombatGraph_SetFrame();
end

function CombatGraph_BackgroundColor_Change()
	local r, g, b = ColorPickerFrame:GetColorRGB();

	CombatGraph_BGColor.r=r;
	CombatGraph_BGColor.g=g;
	CombatGraph_BGColor.b=b;
	CombatGraph_SetFrame();

	CombatGraph_BGColor_BG:SetVertexColor(CombatGraph_BGColor.r,CombatGraph_BGColor.g,CombatGraph_BGColor.b);
end

function CombatGraph_BGOpacity_Change()

	CombatGraph_BGColor.a=1.0-OpacitySliderFrame:GetValue();
	CombatGraph_SetFrame();
end

function CombatGraph_BackgroundColor_Cancel(prev)

	CombatGraph_BGColor=prev;
	CombatGraph_SetFrame();
	CombatGraph_BGColor_BG:SetVertexColor(CombatGraph_BGColor.r,CombatGraph_BGColor.g,CombatGraph_BGColor.b);
end


function CombatGraph_Bar1_DropDown_OnLoad()
	UIDropDownMenu_Initialize(this, CombatGraph_Bar1_DropDown_Initialize);
end


function CombatGraph_Bar1_DropDown_Initialize()	
	info = {};
	info.text = "Damage";
	info.value = CG_DPS;
	info.func = CombatGraph_Bar1_DropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Damage Received";
	info.value = CG_RDPS;
	info.func = CombatGraph_Bar1_DropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Healing";
	info.value = CG_HPS;
	info.func = CombatGraph_Bar1_DropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Healing Received";
	info.value = CG_RHPS;
	info.func = CombatGraph_Bar1_DropDown_OnClick;
	UIDropDownMenu_AddButton(info);
	
	UIDropDownMenu_SetSelectedID(CombatGraph_Bar1_DropDown,CombatGraph_Bar1_Tracking);
end

function CombatGraph_Bar1_DropDown_OnClick()
	UIDropDownMenu_SetSelectedValue(CombatGraph_Bar1_DropDown, this.value);
	CombatGraph_Bar1_Tracking=this.value;
end


function CombatGraph_Bar2_DropDown_OnLoad()
	UIDropDownMenu_Initialize(this, CombatGraph_Bar2_DropDown_Initialize);
end


function CombatGraph_Bar2_DropDown_Initialize()	
	info = {};
	info.text = "Damage";
	info.value = CG_DPS;
	info.func = CombatGraph_Bar2_DropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Damage Received";
	info.value = CG_RDPS;
	info.func = CombatGraph_Bar2_DropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Healing";
	info.value = CG_HPS;
	info.func = CombatGraph_Bar2_DropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Healing Received";
	info.value = CG_RHPS;
	info.func = CombatGraph_Bar2_DropDown_OnClick;
	UIDropDownMenu_AddButton(info);
	
	UIDropDownMenu_SetSelectedID(CombatGraph_Bar2_DropDown,CombatGraph_Bar2_Tracking);
end

function CombatGraph_Bar2_DropDown_OnClick()
	UIDropDownMenu_SetSelectedValue(CombatGraph_Bar2_DropDown, this.value);
	CombatGraph_Bar2_Tracking=this.value;
end

function CombatGraph_Bar2_Enabled_Clicked()
	if(CombatGraph_Bar2_Enabled_CheckBox:GetChecked()) then
		CombatGraph_Bar2_Enabled=true;
		HPS_Text1:Show();
		HPS_Text2:Show();
		AvgHPS_Text1:Show();
		AvgHPS_Text2:Show();
	else
		CombatGraph_Bar2_Enabled=false;
		HPS_Text1:Hide();
		HPS_Text2:Hide();
		AvgHPS_Text1:Hide();
		AvgHPS_Text2:Hide();
	end
end
-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
-- parses CHAT_MSG_SPELL/COMBAT messages to .Last running totals
--
-- This is the old version that used ParserLib and grabbed data from the now
-- nonexistant CHAT_MSG_SPELL/COMBAT events - kept for reference
--
-- The new function to replace it is "ParseCombat", below this function
--function CG_Combat_OnEvent(event,info)
--
--	local playerUnitName = UnitName("Player");
--
--	if ((info.type   == "hit")           and 
--	    (info.source == ParserLib_SELF)  and 
--	    (info.victim ~= ParserLib_SELF)) then 
--
--		CG_DamageMeters_AddDamage(playerUnitName, info.amount);
--
--	elseif ((info.type   == "hit")           and 
--	        (info.source == ParserLib_SELF)  and 
--	        (info.victim == ParserLib_SELF)) then 
--
--		CG_DamageMeters_AddDamageReceived(playerUnitName, info.amount);
--
--	elseif ((info.type   == "hit")           and 
--	        (info.source ~= ParserLib_SELF)  and 
--	        (info.victim ~= ParserLib_SELF)) then 
--
--		CG_DamageMeters_AddDamage(info.source, info.amount);
--
--	elseif ((info.type   == "hit")           and 
--	        (info.source ~= ParserLib_SELF)  and 
--	        (info.victim == ParserLib_SELF)) then 
--
--		CG_DamageMeters_AddDamageReceived(playerUnitName, info.amount);
--
--	elseif ((info.type   == "enviroment")    and 
--	        (info.victim == ParserLib_SELF)) then 
--
--		CG_DamageMeters_AddDamageReceived(playerUnitName, info.amount);
--
--	elseif ((info.type   == "heal")          and 
--   	        (info.source == ParserLib_SELF)  and 
--	        (info.victim == ParserLib_SELF)) then 
--
--		CG_DamageMeters_AddHealing(playerUnitName, playerUnitName, info.amount);
--
--	elseif ((info.type   == "heal")          and 
--   	        (info.source == ParserLib_SELF)  and 
--	        (info.victim ~= ParserLib_SELF)) then 
--
--		CG_DamageMeters_AddHealing(playerUnitName, info.victim , info.amount);
--
--	elseif ((info.type   == "heal")          and 
--   	        (info.source ~= ParserLib_SELF)  and 
--	        (info.victim ~= ParserLib_SELF)) then 
--
--		CG_DamageMeters_AddHealing(info.source, info.victim , info.amount);
--
--	elseif ((info.type   == "heal")          and 
--   	        (info.source ~= ParserLib_SELF)  and 
--	        (info.victim == ParserLib_SELF)) then 
--
--		CG_DamageMeters_AddHealing(info.source, playerUnitName , info.amount);
--	end
--
--end

-- parses COMBAT_LOG_EVENT_UNFILTERED messages to .Last running totals
function ParseCombat(arg1, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
  if not COMBAT_EVENTS[event] then return end

  local playerUnitName = UnitName("Player")
  local toPlayer, fromPlayer, toPet, fromPet, toTarget
  if (sourceName and not CombatLog_Object_IsA(sourceFlags, COMBATLOG_OBJECT_NONE) ) then
    fromPlayer = CombatLog_Object_IsA(sourceFlags, COMBATLOG_FILTER_MINE)
    fromPet = CombatLog_Object_IsA(sourceFlags, COMBATLOG_FILTER_MY_PET)
  end
  if (destName and not CombatLog_Object_IsA(destFlags, COMBATLOG_OBJECT_NONE) ) then
    toPlayer = CombatLog_Object_IsA(destFlags, COMBATLOG_FILTER_MINE)
    toPet = CombatLog_Object_IsA(destFlags, COMBATLOG_FILTER_MY_PET)
  end

  local amount

  ------------damage----------------
  if event == "SWING_DAMAGE" or event == "RANGE_DAMAGE" or event == "SPELL_DAMAGE" or event == "SPELL_PERIODIC_DAMAGE" or event == "ENVIRONMENTAL_DAMAGE" or event == "DAMAGE_SHIELD" or event == "DAMAGE_SPLIT" then
    if event == "SWING_DAMAGE" then
      amount = select(1, ...)
    elseif event == "ENVIRONMENTAL_DAMAGE" then
      _, amount = select(1, ...)
    else
      _, _, _, amount = select(1, ...)
    end

    --Consolidate player and pet damage
    if fromPlayer or fromPet then
      if (not toPlayer) and (not toPet) then
        CG_DamageMeters_AddDamage(playerUnitName, amount)
      elseif toPlayer then
	  --If you hurt yourself....
        --elseif because we don't want to track damage done to yourself as DPS
        CG_DamageMeters_AddDamageReceived(playerUnitName, amount)
      end
    end
    --Damage from someone other than player
    if (not fromPlayer) and (not fromPet) then
      CG_DamageMeters_AddDamage(sourceName, amount)
    end
    --Add damage received to target
    CG_DamageMeters_AddDamageReceived(destName, amount)

  ------------heals----------------
  elseif event == "SPELL_HEAL" or event == "SPELL_PERIODIC_HEAL" then
    _, _, _, amount = select(1, ...)

    if fromPlayer or fromPet then
      if toPlayer then
        CG_DamageMeters_AddHealing(playerUnitName, playerUnitName, amount)
      elseif (not toPlayer) then
        CG_DamageMeters_AddHealing(playerUnitName, destName, amount)
      end
    elseif (not fromPlayer) and (not fromPet) then
      if toPlayer then
        CG_DamageMeters_AddHealing(sourceName, playerUnitName, amount)
      else
        CG_DamageMeters_AddHealing(sourceName, destName, amount);
      end
    end
  end
end

--DamageMeters Encapsulation Functions
-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CG_DamageMeters_AddDamage(player, amount)
	if(player==CombatGraph_Bar1_Target) then
		if(CombatGraph_Bar1_Tracking==CG_DPS) then
			Damage_Current=amount+Damage_Current;
		end
	end
	if(player==CombatGraph_Bar2_Target) then
		if(CombatGraph_Bar2_Tracking==CG_DPS) then
			Healing_Current=amount+Healing_Current;
		end
	end
end

function CG_DamageMeters_AddDamageReceived(player, amount)
	if(player==CombatGraph_Bar1_Target) then
		if(CombatGraph_Bar1_Tracking==CG_RDPS) then
			Damage_Current=amount+Damage_Current;
		end
	end
	if(player==CombatGraph_Bar2_Target) then
		if(CombatGraph_Bar2_Tracking==CG_RDPS) then
			Healing_Current=amount+Healing_Current;
		end
	end
end


function CG_DamageMeters_AddDamage_OLD(player, amount, crit, relationship, spell)
	if(player==CombatGraph_Bar1_Target) then
		if(CombatGraph_Bar1_Tracking==CG_DPS) then
			Damage_Current=amount+Damage_Current;
		end
	end
	if(player==CombatGraph_Bar2_Target) then
		if(CombatGraph_Bar2_Tracking==CG_DPS) then
			Healing_Current=amount+Healing_Current;
		end
	end
end

function CG_DamageMeters_AddDamageReceived_OLD(player, amount, crit, relationship, spell, damageType, resisted)
	if(player==CombatGraph_Bar1_Target) then
		if(CombatGraph_Bar1_Tracking==CG_RDPS) then
			Damage_Current=amount+Damage_Current;
		end
	end
	if(player==CombatGraph_Bar2_Target) then
		if(CombatGraph_Bar2_Tracking==CG_RDPS) then
			Healing_Current=amount+Healing_Current;
		end
	end
end
-- --------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------------------
function CG_DamageMeters_AddHealing(player, target, amount)
	if(player==CombatGraph_Bar1_Target) then
		if(CombatGraph_Bar1_Tracking==CG_HPS) then
			Damage_Current=amount+Damage_Current;
		end
	end
	if(player==CombatGraph_Bar2_Target) then
		if(CombatGraph_Bar2_Tracking==CG_HPS) then
			Healing_Current=amount+Healing_Current;
		end
	end
	
	if(target==CombatGraph_Bar1_Target) then
		if(CombatGraph_Bar1_Tracking==CG_RHPS) then
			Damage_Current=amount+Damage_Current;
		end
	end
	if(target==CombatGraph_Bar2_Target) then
		if(CombatGraph_Bar2_Tracking==CG_RHPS) then
			Healing_Current=amount+Healing_Current;
		end
	end
end

function CG_DamageMeters_AddHealing_OLD(player, target, amount, crit, relationship, targetRelationship, spell)
	if(player==CombatGraph_Bar1_Target) then
		if(CombatGraph_Bar1_Tracking==CG_HPS) then
			Damage_Current=amount+Damage_Current;
		end
	end
	if(player==CombatGraph_Bar2_Target) then
		if(CombatGraph_Bar2_Tracking==CG_HPS) then
			Healing_Current=amount+Healing_Current;
		end
	end
	
	if(target==CombatGraph_Bar1_Target) then
		if(CombatGraph_Bar1_Tracking==CG_RHPS) then
			Damage_Current=amount+Damage_Current;
		end
	end
	if(target==CombatGraph_Bar2_Target) then
		if(CombatGraph_Bar2_Tracking==CG_RHPS) then
			Healing_Current=amount+Healing_Current;
		end
	end
end

-- --------------------------------------------------------------------------------
